function [e,R] = MGS_normalize(A)
%UNTITLED2 Summary of this function goes here
%   Detailed explanation goes here
[M,N] = size(A);
e = zeros(M,N);
R = zeros(M,N);
for i = 1:N
    if (i==1)
    u = A(:,1);
    e(:,1) = u/norm(u);
    R(1,1) = e(:,1)'*A(:,1);
    else
    tmp = zeros(N,1);
    for j = 1:i-1
        R(j,i) = e(:,j)'*A(:,i);
        tmp = tmp + R(j,i)*e(:,j);
    end
    u = A(:,i) - tmp;
    e(:,i) = u/norm(u);
    R(i,i) = e(:,i)'*A(:,i);
    end
end
end

% function [Q, R] = mgson(X)
% % Modified Gram-Schmidt orthonormalization (numerical stable version of Gram-Schmidt algorithm) 
% % which produces the same result as [Q,R]=qr(X,0)
% % Written by Mo Chen (sth4nth@gmail.com).
% [d,n] = size(X);
% m = min(d,n);
% R = zeros(m,n);
% Q = zeros(d,m);
% for i = 1:m
%     v = X(:,i);
%     for j = 1:i-1
%         R(j,i) = Q(:,j)'*v;
%         v = v-R(j,i)*Q(:,j);
%     end
%     R(i,i) = norm(v);
%     Q(:,i) = v/R(i,i);
% end
% R(:,m+1:n) = Q'*X(:,m+1:n);