
function [Q,G,J] = Givens_QR(A)
[M,~] = size(A);
G = A;
Q = eye(M);
    for i = 1:M-1
        for j = i+1:M
        J = eye(M);
        cs = G(i,i)/(sqrt(G(i,i)^2 + G(j,i)^2));
        sn = G(j,i)/(sqrt(G(i,i)^2 + G(j,i)^2));
        J(i,i) = cs; J(i,j) = sn;
        J(j,i) = -sn; J(j,j) = cs;
        G = J*G; 
        Q = Q*J';
        end
    end
end
